haveAskedFeedback = false;
statusBar = document.getElementById("statusBar");
remoteHostTextBox = document.getElementById("remoteHost");
origRemoteHostTextBoxBkgnd = "";
if (remoteHostTextBox!==null) {
	origRemoteHostTextBoxBkgnd = remoteHostTextBox.style.background;
}

function setStatusText(text) {
	statusBar.innerHTML = text;
}

function server_onfocus() {
	if (remoteHostTextBox!==null) {
	  remoteHostTextBox.style.backgroundImage = "";
	}
}
	
function server_onblur() {
  if (remoteHostTextBox!==null && remoteHostTextBox.value==="") {
	remoteHostTextBox.style.background = origRemoteHostTextBoxBkgnd;
  }
}

function remoteTextBox_KeyPress(ev) 
{
	var keyCode = null;
	if (window.event) {
		keyCode = window.event.keyCode;
	} else if (ev) {
		keyCode = ev.which;
	}
	if (keyCode===13) {
		connectButton_clicked();
	}
}

function connectButton_clicked() {
	if (!onloadCalled) {
		window_onload() ;
	}
	if (!navigator.javaEnabled()) {
		if (confirm("You need to have Java installed and enabled to use Integral FTP.  Would you like instructions on how to do this?")) {
			window.location = "http://www.integralftp.com/help/enablingJava.html";
		}
		return;
	}
	if (ftp===null || !ftp.isConnected()) {
		if (remoteHostTextBox.value=="") {
			alert("Please enter the server address");
			return;
		}
		if (userNameTextBox.value.trim()==="") {
			userNameTextBox.value = "anonymous";
		}
		var userName = prompt("Please enter the user-name:", userNameTextBox.value);
		if (userName!==null) {
			userNameTextBox.value = userName.trim();
			var anonymousLogin = (userName==="anonymous");
			if (anonymousLogin) {
				passwordTextBox.value = "user@integralftp.com";
			}
			var password = prompt("Please enter the password:", passwordTextBox.value);
			if (password!==null) {
		        	passwordTextBox.value = password.trim();
				connect_clicked();
			}
		}
	} else {
		var disconnecting = (ftp!==null && ftp.isConnected);
		
		connect_clicked();
		
		if (disconnecting && !haveAskedFeedback) {
//			if (confirm("Could you please provide us with some feedback on Integral FTP?"))
//				window.location = "mailto:support@enterprisedt.com?subject=Integral FTP feedback";
//			haveAskedFeedback = true;
		}
	}
}
	
// OCAL EVENTS -----------------------------------------------------------------------

function checkLocalFileSelected(action) {
	if (localListBox.selectedIndex<0) {
		alert("Please select a file to " + action + ".");
		return false;
	}
	var option = localListBox.options[localListBox.selectedIndex];
	if (option.text.length>5 && option.text.substring(0, 5)=="<dir>") {
		alert("Directory transfers are not yet supported.  Please select a file.");
		return false;
	}
	return true;
}

function chdirHomeLocal_clicked() {
	localChangeDirectory("");
}

function chdirLocal_clicked() {
	if (!ftp.isInitialized()) {
		alert("You haven't yet connected to the server.\nPlease press Connect/Go.");
		return;
	} else if (localListBox.selectedIndex<0) {
		alert("Please select a directory to change into.");
		return;
	}
	var option = localListBox.options[localListBox.selectedIndex];
	if (option.text.length<5 || option.text.substring(0, 5)!="<dir>") {
		alert("Please select a local to change into.");
		return;
	}
	localChangeDirectory(option.value);
}

function chdirLocalAbs_clicked() {
	if (!ftp.isInitialized()) {
		alert("You haven't yet connected to the server.\nPlease press Connect/Go.");
		return;
	} else if (localWorkDir!==null) {
		var newDir = prompt("Enter local directory to change into", localWorkDir);
		if (newDir!==null) {
			localChangeDirectory(newDir);
		}
	}
}

function newDirLocal_clicked() {
	if (!ftp.isInitialized()) {
		alert("You haven't yet connected to the server.\nPlease press Connect/Go.");
		return;
	} else if (localWorkDir!==null) {
		localCreateDir();
	}
}

function upload_clicked() {
	if (checkConnected() && checkLocalFileSelected("upload")) {
		var selectedItems = getListItems(localListBox.options, true);
		for (var i=0; i<selectedItems.length; i++) {
			uploadFile( selectedItems[i].text,  selectedItems[i].value);
		}
	}
}

function deleteLocal_clicked() {
	if (!ftp.isInitialized()) {
		alert("You haven't yet connected to the server.\nPlease press Connect/Go.");
		return;
	} else if (localListBox.selectedIndex<0) {
		alert("Please select a file or folder to delete.");
		return false;
	}
	var selectedItems = getListItems(localListBox.options, true);
	for (var i=0; i<selectedItems.length; i++) {
		var item = selectedItems[i];
		var file = item.text;
		if (file.length>=5 && file.substring(0, 5)==="<dir>") {
			file = file.substring(5).trim();
		}
		localDeleteFile(file, item.value, i===selectedItems.length-1);
	}
}

function renameLocal_clicked() {
	if (!ftp.isInitialized()) {
		alert("You haven't yet connected to the server.\nPlease press Connect/Go.");
		return;
	} else if (localListBox.selectedIndex<0) {
		alert("Please select a file or folder to rename.");
		return false;
	}
	var option = localListBox.options[localListBox.selectedIndex];
	localRename(option.text, option.value);
}

function viewLocal_clicked() {
	if (!ftp.isInitialized()) {
		alert("You haven't yet connected to the server.\nPlease press Connect/Go.");
		return;
	} else if (checkLocalFileSelected("view")) {
		var option = localListBox.options[localListBox.selectedIndex];
		localViewFile(option.text, option.value);
	}
}

function localClick() {
	showFileInfo(localFileList, localListBox, true);
}
	
function localDblClick() {
	if (localListBox.selectedIndex<0) {
		return false;
	}
	var option = localListBox.options[localListBox.selectedIndex];
	if (option.text.length>5 && option.text.substring(0, 5)=="<dir>") {
		chdirLocal_clicked();
	} else {
		upload_clicked();
	}
}
	
// REMOTE EVENTS -----------------------------------------------------------------------

function checkRemoteFileSelected(action) {
	if (remoteListBox.selectedIndex<0) {
		alert("Please select a file to " + action + ".");
		return;
	}
	var option = remoteListBox.options[remoteListBox.selectedIndex];
	if (option.text.length>5 && option.text.substring(0, 5)=="<dir>") {
		alert("Directory transfers are not yet supported.  Please select a file.");
		return;
	}
	return true;
}

function chdirHomeRemote_clicked() {
	remoteChangeDirectory(initialRemoteDir);
}

function chdirRemote_clicked() {
	if (!checkConnected()) {
		return;
	}
	if (remoteListBox.selectedIndex<0) {
		alert("Please select a server directory to change into.");
		return;
	}
	var option = remoteListBox.options[remoteListBox.selectedIndex];
	if (option.text.length<5 || option.text.substring(0, 5)!="<dir>") {
		alert("Please select a server directory to change into.");
		return;
	}
	remoteChangeDirectory(option.value);
}

function chdirRemoteAbs_clicked() {
	if (!checkConnected()) {
		return;
	}
	if (remoteWorkDir!==null) {
		var newDir = prompt("Enter server directory to change into", remoteWorkDir);
		if (newDir!==null) {
			remoteChangeDirectory(newDir);
		}
	}
}

function newDirRemote_clicked() {
	if (!checkConnected()) {
		return;
	}
	remoteCreateDir();
}

function download_clicked() {
	if (checkConnected() && checkRemoteFileSelected("download")) {
		var selectedItems = getListItems(remoteListBox.options, true);
		for (var i=0; i<selectedItems.length; i++) {
			downloadFile(selectedItems[i].text);
		}
	}
}

function deleteRemote_clicked() {
	if (!checkConnected()) {
		return;
	}
	if (remoteListBox.selectedIndex<0) {
		alert("Please select a file or folder to delete.");
		return;
	}
	var selectedItems = getListItems(remoteListBox.options, true);
	for (var i=0; i<selectedItems.length; i++) {
		var file = selectedItems[i].text;
		if (file.length>=5 && file.substring(0, 5)==="<dir>") {
			file = file.substring(5).trim();
			remoteDeleteDirectory(file, i===selectedItems.length-1);
		} else {
			remoteDeleteFile(file, i===selectedItems.length-1);
		}
	}
}

function renameRemote_clicked() {
	if (!checkConnected()) {
		return;
	}
	if (remoteListBox.selectedIndex<0) {
		alert("Please select a file or folder to rename.");
		return;
	}
	var option = remoteListBox.options[remoteListBox.selectedIndex];
	remoteRename(option.text);
}

function viewRemote_clicked() {
	if (checkConnected() && checkRemoteFileSelected("view")) {
		var option = remoteListBox.options[remoteListBox.selectedIndex];
		remoteViewFile(option.text);
	}
}

function showLocalDir() {
	if (localWorkDir!==null) {
		setStatus("Local: " + localWorkDir);
	}
}

function showRemoteDir() {
	if (remoteWorkDir!==null) {
		setStatus("Server: " + remoteWorkDir);
	}
}
	
function remoteClick() {
	showFileInfo(remoteFileList, remoteListBox, false);
}
	
function remoteDblClick() {
	if (remoteListBox.selectedIndex<0) {
		return false;
	}
	var option = remoteListBox.options[remoteListBox.selectedIndex];
	if (option.text.length>5 && option.text.substring(0, 5)=="<dir>") {
		chdirRemote_clicked();
	} else {
		download_clicked();
	}
}

// HELPER FUNCTIONS ----------------------------------------------------------

function checkConnected() {
	if (!ftp.isConnected()) {
		alert("You haven't yet connected to the server.\nPlease press Connect/Go.");
		return;
	} else  {
		return true;
	}
}

function showFileInfo(fileList, listBox, showSeconds) {
	if (fileList!==null && listBox.selectedIndex>=0) {
		var option = listBox.options[listBox.selectedIndex];
		for (var i=0; i<fileList.files.length; i++) {
			var file = fileList.files[i];
			if (file.path===option.value) {
				if (file.modifiedDate===null) {
					return;
				}
				var text = file.name + ": ";
				if (!file.isDirectory) {
					var fileSize = new FTPFileSize(file.size);
					text += "<font color='blue'>" + fileSize.numberString + " " + fileSize.units + "</font> - ";
				}
				text +=  "<font color='green'>" + file.modifiedDate.toFTPString(showSeconds) + "</font>";
				setStatus(text, false, false);
				break;
			}
		}
	}
}

function ListItem(option) {
	this.text = option.text;
	this.value = option.value;
	this.selected = option.selected;
}

function getListItems(options, selectedOnly) {
	var items = [];
	for (var i=0; i<options.length; i++) {
		if (!selectedOnly || options[i].selected) {
			items.push(new ListItem(options[i]));
		}
	}
	return items;
}

